// BeauGaugeExample001Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "BeauGaugeExample001.h"
#include "BeauGaugeExample001Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBeauGaugeExample001Dlg dialog




CBeauGaugeExample001Dlg::CBeauGaugeExample001Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBeauGaugeExample001Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBeauGaugeExample001Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	for(int i = 0 ; i < 8 ; i++ )
	{
		DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL1 + i, m_gauge[i]);
	}	
}

BEGIN_MESSAGE_MAP(CBeauGaugeExample001Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CBeauGaugeExample001Dlg message handlers

BOOL CBeauGaugeExample001Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	SetTimer(1,1,NULL);
	SetTimer(2,500,NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBeauGaugeExample001Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBeauGaugeExample001Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBeauGaugeExample001Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CBeauGaugeExample001Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if(1 == nIDEvent)
	{
		static int nValue = 0;
		//m_gauge[0].SetValue(_T("Pointer1"),nValue);
		m_gauge[1].SetValue(_T("Pointer1"),nValue);
		m_gauge[1].SetValue(_T("Pointer2"),nValue);
		m_gauge[7].SetValue(_T("Pointer1"),nValue);
		nValue++;
		if(nValue>100)
			nValue = 0;
	}

	if(2 == nIDEvent)
	{
		static BOOL b1 = TRUE;
		//m_gauge[5].SetValue(_T("ImageStateIndicator1"),b1);
		m_gauge[6].SetValue(_T("ImageStateIndicator1"),!b1);
		b1 = !b1;
	}

	CDialog::OnTimer(nIDEvent);
}

void CBeauGaugeExample001Dlg::OnDestroy()
{
	CDialog::OnDestroy();

	KillTimer(1);
	KillTimer(2);
}

BEGIN_EVENTSINK_MAP(CBeauGaugeExample001Dlg, CDialog)
	ON_EVENT(CBeauGaugeExample001Dlg, IDC_BGV2ACTIVEXCTRL3, 1, CBeauGaugeExample001Dlg::ValueChangeBgv2activexctrl3, VTS_BSTR VTS_R8)
	ON_EVENT(CBeauGaugeExample001Dlg, IDC_BGV2ACTIVEXCTRL4, 1, CBeauGaugeExample001Dlg::ValueChangeBgv2activexctrl4, VTS_BSTR VTS_R8)
	ON_EVENT(CBeauGaugeExample001Dlg, IDC_BGV2ACTIVEXCTRL5, 1, CBeauGaugeExample001Dlg::ValueChangeBgv2activexctrl4, VTS_BSTR VTS_R8)
	//ON_EVENT(CBeauGaugeExample001Dlg, IDC_BGV2ACTIVEXCTRL5, 1, CBeauGaugeExample001Dlg::ValueChangeBgv2activexctrl5, VTS_BSTR VTS_R8)
END_EVENTSINK_MAP()

void CBeauGaugeExample001Dlg::ValueChangeBgv2activexctrl3(LPCTSTR sName, double fValue)
{
	m_gauge[0].SetValue(_T("Pointer1"),fValue);
}


void CBeauGaugeExample001Dlg::ValueChangeBgv2activexctrl4(LPCTSTR sName, double fValue)
{
	static BOOL b2 = TRUE;
	m_gauge[5].SetValue(_T("ImageStateIndicator1"),b2);
	b2 = !b2;
}

//void CBeauGaugeExample001Dlg::ValueChangeBgv2activexctrl5(LPCTSTR sName, double fValue)
//{
//}
